/**
   @author Yasuhiro Masutani
*/

#include <cnoid/BodyIoRTC>

using namespace std;
using namespace cnoid;

namespace {

class TestBodyIoRTC : public BodyIoRTC
{
public:
    TestBodyIoRTC(RTC::Manager* manager);
    ~TestBodyIoRTC(); 

    virtual bool initializeIO(ControllerIO* io) override;
    virtual bool initializeSimulation(ControllerIO* io) override;
    virtual void inputFromSimulator() override;
    virtual void outputToSimulator() override;
};

const char* spec[] =
{
    "implementation_id", "TestBodyIoRTC",
    "type_name",         "TestBodyIoRTC",
    "description",       "DoubleArmV7 with PD Controller I/O",
    "version",           "1.0",
    "vendor",            "MasutaniLab",
    "category",          "Generic",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
};

}

TestBodyIoRTC::TestBodyIoRTC(RTC::Manager* manager)
    : BodyIoRTC(manager)
{
}

TestBodyIoRTC::~TestBodyIoRTC()
{
}

bool TestBodyIoRTC::initializeIO(ControllerIO* io)
{
    return true;
}

bool TestBodyIoRTC::initializeSimulation(ControllerIO* io)
{
    string option = io->optionString();
    io->os() << "Controller option: " << option << endl;
    return true;
}

void TestBodyIoRTC::inputFromSimulator()
{
}

void TestBodyIoRTC::outputToSimulator()
{
}

extern "C"
{
    DLL_EXPORT void TestBodyIoRTCInit(RTC::Manager* manager)
    {
        coil::Properties profile(spec);
        manager->registerFactory(
            profile, RTC::Create<TestBodyIoRTC>, RTC::Delete<TestBodyIoRTC>);
    }
};